package com.hello2morrow.sonargraph.languageprovider.java.command.system.scripts

import static org.junit.Assert.*

import com.hello2morrow.sonargraph.core.model.element.Severity
import com.hello2morrow.sonargraph.core.model.script.GroovyScript
import com.hello2morrow.sonargraph.core.model.script.ScriptIssueElementTreeNode
import com.hello2morrow.sonargraph.core.model.script.ScriptNamedTreeNode
import com.hello2morrow.sonargraph.core.model.script.ScriptResultSet
import com.hello2morrow.sonargraph.core.model.script.ScriptSeverityTreeNode
import com.hello2morrow.sonargraph.languageprovider.java.foundation.common.JavaTestFixture;

class UnusedTypesScriptTest extends AbstractJavaScriptTest {
    private static final String SCRIPT_PATH = JavaTestFixture.SCRIPT_UNUSED_TYPES_SCRIPT_PATH;
    private static final String PROJECT_PATH = JavaTestFixture.SCRIPT_UNUSED_TYPES_PROJECT_PATH;

    public UnusedTypesScriptTest() {
        super(PROJECT_PATH, SCRIPT_PATH);
    }

    @Override
    void verifyResult(GroovyScript script) {
        ScriptResultSet result = script.getResultSet();
        assertEquals(4, result.getNamedElements().size());

        ScriptNamedTreeNode issues = result.getIssueRootNode();

        List<ScriptSeverityTreeNode> scriptWarnings = issues.getChildren().findAll {
            if (it instanceof ScriptSeverityTreeNode) {
                ScriptSeverityTreeNode node = (ScriptSeverityTreeNode) it;
                if (node.getSeverity() == Severity.WARNING) {
                    return node;
                }
                return null;
            }
        }
        assertEquals(1, scriptWarnings.size());
        
        ScriptSeverityTreeNode severityNode = scriptWarnings.get(0);
        List<ScriptIssueElementTreeNode> warningNodes = severityNode.getChildren().get(0).getChildren().findAll
        { it instanceof ScriptIssueElementTreeNode }

        assertEquals(2, warningNodes.size());
    }
}
